<?php

function Bread($whereami)
{
  $bread = "<div id='breadcrumbs'>";
  $bread .= "<a href='http://centos.rutgers.edu/'>centos.rutgers.edu</a> &gt; ";
  $bread .= "<a href='" . site_url() . "'>rpm2php</a> &gt; ";
  foreach ($whereami as $pos)
    $bread .= $pos . " &gt; ";
  $bread = substr($bread, 0, -6) . "</div>";
  return $bread;
}

function GenMenu($user, $queuelist=FALSE)
{
  $mymenu = "<div id='menu'>";
  $mymenu .= "\n  <div style = 'float: left; padding-left: 10px; padding-top: 5px;'>";
  if ($user)
    $mymenu .= "Hello " . $user . ". ";
  $mymenu .= "Welcome to rpm.rutgers.edu, provided by Open System Solutions</div>";

  /*// For the private network comment these out
    // FIXME: Apache for public network runs on a different machine than omachi
    //        so this script can't access /var/lock/ of omachi
    //        How should we handle this?
  $mymenu .= "<div style='float: right; padding-right: 10px; padding-top: 5px;'>";
  $chk = checkQueue($queuelist, True);
  if ($chk)
    $mymenu .= $chk . " - ";
  $mymenu .= " - <a href='http://centos.rutgers.edu/koji/'>Koji</a>";
  $mymenu .= "\n</div>";
  */
  // ENDOF: For the private network comment these out

  // For the public network comment these out
  $mymenu .= "<div style='float: right; padding-right: 10px; padding-top: 5px;'>";

  if ($user)
    {
      $mymenu .= "<a href='https://jla.rutgers.edu/webtools/tiki/tiki-index.php?page=Publishing+CentOS+packages+via+Web+interface' target='_blank'>Help</a> - ";
      $urlarray = explode("://", site_url("logout.php"));
      $url = $urlarray[0] . "://log:out@" . $urlarray[1];
      $mymenu .= checkQueue($queuelist);
      $mymenu .= " - <a href='https://192.168.226.90/koji/'>Koji</a>";
      $mymenu .= " - <a href='" . $url . "'>Logout</a>";
    }
  else
    $mymenu .= "<a href='" . site_url("login.php") . "'>Login</a>";
  $mymenu .= "\n  </div>";
  
  // END OF: For the public network comment these out

  $mymenu .= "\n</div>";
  return $mymenu;
}

function SortSearchResults($search_results, $user, $fail_message="Sorry, no results returned.")
{
  $output = "";
  $output .= "<script type='text/javascript' src='" . base_url() ."js/js_tooltips.js'></script>";
  $output .= "\n<table id='resultsTable'>";
  $output .="\n<tr><th>Name</th><th>Summary</th><th style='width: 90px;'>Stable</th><th style='width: 90px;'>Testing</th><th style='width: 90px;'>Unstable</th>";
  if ($user)
    $output .= "<th style='width: 90px;'>Staging</th>";
  $output .= "<th style='width: 76px;'>Arch</th></tr>";

  if($search_results)
    {
      $pkgarray = array();
      $display_results = array();
      foreach ($search_results as $function_info) 
	{
	  $mypos = array_search($function_info->Name, $pkgarray);
	  if ($mypos === FALSE)
	    {
	      $pkgarray[] = $function_info->Name;
	      $pkg = new StdClass;
	      $pkg->Name = $function_info->Name;
	      $pkg->Summary = $function_info->Summary;
	      $repo = $function_info->repo;
	      $pkg->$repo = new StdClass;
	      $pkg->$repo->vr = $function_info->Version . "-" . $function_info->Rel;
	      $pkg->$repo->rpm_id = $function_info->rpm_id;
	      $pkg->$repo->build_id = $function_info->build_id;
	      $pkg->Archs = array($function_info->Arch);
	      $display_results[] = $pkg;
	    }
	  else
	    {
	      for ($i=0; $i < sizeof($display_results); ++$i)
		{
		  if ($display_results[$i]->Name == $function_info->Name)
		    {
		      $repo = $function_info->repo;
		      if (isset($display_results[$i]->$repo))
			{
			  if ($display_results[$i]->$repo->build_id > $function_info->build_id)
			    {
			      continue;
			    }
			}
		      $display_results[$i]->$repo = new StdClass;
		      $display_results[$i]->$repo->vr = $function_info->Version . "-" . $function_info->Rel;
		      $display_results[$i]->$repo->rpm_id = $function_info->rpm_id;
		      $display_results[$i]->$repo->build_id = $function_info->build_id;
		      if (in_array($function_info->Arch, $display_results[$i]->Archs) == FALSE)
			{
			  $display_results[$i]->Archs[] = $function_info->Arch;
			  sort($display_results[$i]->Archs);
			}
		    }
		}
	    }
	}
      $divinfo = "";
      foreach ($display_results as $display_info)
	{
	  if(strlen($display_info->Name)  > 30)
	    {
	      $display_info->Name=substr($display_info->Name,0,23) . "..." . substr($display_info->Name,-4); 
	    }
	  $output .= "\n<tr><td><strong>" . $display_info->Name . '</strong></td>';
	  $output .= "\n<td>" . $display_info->Summary . '</td>';
	  if ($user)
	    $reposarray = array('centos5-rutgers', 'centos5-rutgers-testing', 'centos5-rutgers-unstable', 'centos5-rutgers-staging');
	  else
	    $reposarray = array('centos5-rutgers', 'centos5-rutgers-testing', 'centos5-rutgers-unstable');
	  foreach ($reposarray as $myrepo)
	    if (isset($display_info->$myrepo))
	      {
		$fixurl = site_url('index.php/packages/index/'.$display_info->$myrepo->rpm_id.'');
		//$output .= "<td class='" . $myrepo . "'><strong><a href='" . $fixurl . "'>" . $display_info->$myrepo->vr . "</a></strong></td>";
		$cvr = CuteVR($myrepo, $fixurl, $display_info->$myrepo->vr, $display_info->$myrepo->rpm_id);
		$output .= $cvr[0];
		$divinfo .= $cvr[1];
	      }
	    else
	      {
		$output .= "\n<td class='" . $myrepo . "'></td>";
	      }
	  $output .= "\n<td>" . implode(", ", $display_info->Archs) . '</td></tr>';
	}
      $output .= "\n</table>";
      $output .= $divinfo;
      
    } else{
    $output = "\n<p>" . $fail_message . "</p>";
  }
  return $output;
}

function CuteVR($repo, $url, $vr, $rpm_id)
{
  $cutat = 12;
  if(strlen($vr)  > $cutat+3)
    {
      $vrcut=substr($vr,0,$cutat) . "...";
      $output = "\n<td class='" . $repo . "'><strong><a href='" . $url . "'><span class='ttip' id='" . $repo . "-" . $rpm_id . "'>" . $vrcut . "</span></a></strong></td>";
      $divinfo ="\n<div id='t" . $repo . "-" . $rpm_id . "' class='info-" . $repo . "'>" . $vr . "</div>";
    }
  else
    {
      $output = "\n<td class='" . $repo . "'><strong><a href='" . $url . "'>" . $vr . "</a></strong></td>";
      $divinfo = NULL;
    }
  return array($output, $divinfo);
}

function getCookie()
{
  $queuelist = explode("s", $_COOKIE['QueuedRPMs']);

  for ($i=0; $i<sizeof($queuelist); ++$i)
    if (is_numeric($queuelist[$i]) == FALSE)
      unset($queuelist[$i]);

  return $queuelist;
}

function isPushInProgress()
{
 if (file_exists("/var/lock/rutgers-repotools/pushpackage"))
   return TRUE;
 else
   return FALSE;
}

function isUpdateDbInProgress()
{
 if (file_exists("/var/lock/rutgers-repotools/populate-rpmfind-db"))
   return TRUE;
 else
   return FALSE;
}

function checkQueue($queuelist=False, $lite=False)
{
  $mystring = "";
  if ($lite)
    {
      if (isPushInProgress())
	$mystring .= " Push in progress ";
      if (isUpdateDbInProgress())
	$mystring .= " Database update in progress ";
    }
  else
    {
      if (isPushInProgress())
	$mystring .= "<a href='" . site_url("index.php/push/index/") . "'> Push in progress</a>";
      else
	{
	  if ($queuelist === False and isset($_COOKIE['QueuedRPMs']))
	    $queuelist = getCookie();
	  
	  $queuesize = sizeof($queuelist);
	  if ($queuesize == 1 and is_array($queuelist))
	    $mystring .= " <a href='" . site_url("index.php/queue/index/") . "'> 1 package in queue</a>";
	  elseif ($queuesize > 1 and is_array($queuelist))
	    $mystring .= "<a href='" . site_url("index.php/queue/index/") . "'>" . $queuesize . " packages in queue</a>";
	  else
	    $mystring .= " No packages in queue";
	}

      $mystring .= " - ";
      
      if (isUpdateDbInProgress())
	$mystring .= "<a href='" . site_url("index.php/updatedb/index/") . "'>Database update in progress</a>";
      else
	$mystring .= "<a href='" . site_url("index.php/updatedb/index/") . "'>Update database</a>";
    }
  return $mystring;
}

function CfcAuthor($string)
{
  $ltpos = strpos($string, '<');
  $gtpos = strpos($string, '>');

  if ($ltpos === False or $gtpos === False)
    return htmlspecialchars($string, ENT_QUOTES, "UTF-8");

  $email = substr($string,$ltpos-1,$gtpos-$ltpos+2);
  $email = str_replace(array('@', '.'), array(' [at] ', ' [dot] '), $email);
  $final = substr($string,0, $ltpos) . $email . substr($string,$gtpos+1);
  return $final;
  }

function SortDep($dep_obj, $dep_type = NULL)
{
  //dependency flags
  $RPMSENSE_LESS = 2;
  $RPMSENSE_GREATER = 4;
  $RPMSENSE_EQUAL = 8;
  $output = "";

  $mydep = $dep_obj->Resource;
  if ($dep_obj->Flags)
    {
      if ($dep_obj->Flags & ($RPMSENSE_LESS | $RPMSENSE_GREATER | $RPMSENSE_EQUAL))
        {
          $mydep .= " ";
          if ($dep_obj->Flags & $RPMSENSE_LESS) $mydep .= "&lt;";
          if ($dep_obj->Flags & $RPMSENSE_GREATER) $mydep .= "&gt;";
          if ($dep_obj->Flags & $RPMSENSE_EQUAL) $mydep .= "= ";
          if ($dep_obj->Version) $mydep .= $dep_obj->Version;
        }
    }
  if ($dep_type)
    $output .= '<a href="'.site_url('index.php/' . $dep_type . '/index/'.$dep_obj->Resource) .'">'. $mydep . '</a><br />';
  else
    $output .= $mydep . '<br />';
  return $output;
}



?>
